/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.ObjekModulAplikasi;

@Lazy
@Repository
public interface ObjekModulAplikasiDao extends CrudRepository<ObjekModulAplikasi, String> {
	
	String QSelectAll = "select model "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapObjekModulToKelompokUser mkUser "
			+ " left join model.mapObjekModulToModulAplikasi mmApp "
			+ " where mmApp.id.kdProfile = mkUser.id.kdProfile "
//			+ " and model.isMenu = 1"
			+ " and mkUser.id.kdProfile = :kdProfile "
			+ " and mmApp.id.kdModulAplikasi = :kdModulAplikasi "
			+ " and mkUser.id.kdKelompokUser = :kdKelompokUser  "
			+ " and mkUser.tampil = 1 "
			+ " and model.alamatURLFormObjek is not null "
			+ " and model.statusEnabled = true "
			+ " and mmApp.statusEnabled = true " 
			+ " and mkUser.statusEnabled = true";

	@Query(QSelectAll + " and model.kdObjekModulAplikasiHead = :kdObjekModulAplikasiHead ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenu(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdKelompokUser") Integer kdKelompokUser,
			@Param("kdObjekModulAplikasiHead") String kdObjekModulAplikasiHead);
	
	@Query(QSelectAll + " and model.kdObjekModulAplikasiHead is null ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenu(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdKelompokUser") Integer kdKelompokUser);
	
	
	String QSelectAllAdmin = "select model "
			+ " from ObjekModulAplikasi model "
			+ " left join model.mapObjekModulToModulAplikasi mmApp "
			+ " where mmApp.id.kdProfile = :kdProfile "
			+ " and mmApp.id.kdModulAplikasi = :kdModulAplikasi "
//			+ " and model.isMenu = 1"
			+ " and model.alamatURLFormObjek is not null "
			+ " and model.statusEnabled = true "
			+ " and mmApp.statusEnabled = true " ;

	@Query(QSelectAllAdmin + " and model.kdObjekModulAplikasiHead = :kdObjekModulAplikasiHead ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenuAdmin(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi,
			@Param("kdObjekModulAplikasiHead") String kdObjekModulAplikasiHead);
	
	@Query(QSelectAllAdmin + " and model.kdObjekModulAplikasiHead is null ")
	List<ObjekModulAplikasi> findAllObjekModulAplikasiDaofindMenuAdmin(
			@Param("kdProfile") Integer kdProfile, 
			@Param("kdModulAplikasi") String kdModulAplikasi);
	

}
